<!---终端入网检测-->
<template>
  <TableHeader area  ref='TableHeaderRef' showExport showCustomColumn>
    <template #select>
      <el-form-item label='搜索'>
        <el-input
            v-model='tableStore.table.params.searchValue'
            placeholder='输入变电站.终端名称'
            clearable
            maxlength="32"  
            show-word-limit 
        ></el-input>
      </el-form-item>
      <el-form-item label='流程状态'>
        <el-select v-model='tableStore.table.params.status' clearable placeholder='请选择流程状态' filterable>
          <el-option
              v-for='item in statusSelect'
              :key='item.id'
              :label='item.name'
              :value='item.id'
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label='处理状态'>
        <el-select v-model='tableStore.table.params.state' clearable placeholder='请选处理状态' filterable>
          <el-option
              v-for='item in stateSelect'
              :key='item.id'
              :label='item.name'
              :value='item.id'
          ></el-option>
        </el-select>
      </el-form-item>
    </template>
  </TableHeader>
  <Table ref='tableRef' />
  <Form ref='FormRef' @onSubmit='tableStore.index()' />
</template>
<script setup lang='ts'>
import { ref, onMounted, provide, watch } from 'vue'
import TableStore from '@/utils/tableStore'
import { ElMessage, ElMessageBox } from 'element-plus'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useRouter } from 'vue-router'
import { useDictData } from '@/stores/dictData'
import Form from './form.vue'
import { cancel, getInfoById } from '@/api/supervision-boot/cycleDetection/index'
import { useAdminInfo } from '@/stores/adminInfo'
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const dictData = useDictData()
const { push, options, currentRoute } = useRouter()
const flag = ref(false)
const TableHeaderRef = ref()
const tableRef = ref()
const FormRef = ref()
const statusSelect = dictData.statusSelect()
const stateSelect = [
  {
    id: 0,
    name: '未处理'
  },
  {
    id: 1,
    name: '处理中'
  },
  {
    id: 2,
    name: '已处理'
  }
]
//申请联调
const debugForms = ref()
const tableStore = new TableStore({
  url: '/supervision-boot/checkDevice/list',
  publicHeight: 65,
  method: 'POST',
  filename:'终端周期检测',
  column: [
  { title: '序号',  width: 80,formatter: (row: any) => {
        return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
      } },
    { field: 'substation', title: '变电站' },

    { field: 'dept', title: '供电公司' },
    {
      field: 'deviceName',
      title: '终端名称'
    },
    {
      field: 'thisTimeCheck',
      title: '本次定检时间'
    },
    {
      field: 'nextTimeCheck',
      title: '下次定检时间'
    },
    {
      field: 'overdueDay',
      title: '逾期天数',
      type: 'html',
      formatter: (row: any) => {

        let text = row.row.status == 2
            ? '/'
            : `<span style='color: ${
                row.row.overdueDay > 10 ? 'red' : row.row.overdueDay > 3 ? 'yellow' : ''
            };text-decoration: none'>${row.row.overdueDay}</span>`

        return text
      }
    },

    {
      field: 'status',
      title: '流程状态',
      minWidth: 100,
      render: 'tag',
      custom: {
        0: 'warning',
        1: 'primary',
        2: 'success',
        3: 'danger',
        4: 'warning',
        5: 'primary'
      },
      replaceValue: {
        0: '待提交审批',
        1: '审批中',
        2: '审批通过',
        3: '审批不通过',
        4: '已取消',
        5: '同步台账成功',
        null: '/'
      }
    },
    {
       title: '操作',fixed: 'right',
    
      render: 'buttons',
      buttons: [
        {
          name: 'productSetting',
          title: '流程详情',
          type: 'primary',
          icon: 'el-icon-EditPen',
          render: 'basicButton',
          click: row => {
            flag.value = true
            handleAudit(row.processInstanceId, row.historyInstanceId)
          },
          disabled: row => {
            return !row.processInstanceId
          }
        },

        {
          name: 'edit',
          title: '报告上传',
          type: 'primary',
          icon: 'el-icon-Open',
          render: 'basicButton',
          disabled: row => {
            return row.status != null
          },
          click: row => {
            FormRef.value.open('报告上传', row)
          }
        },

        {
          name: 'edit',
          title: '重新发起',
          type: 'warning',
          icon: 'el-icon-Open',
          render: 'basicButton',
          disabled: row => {
            return row.createBy != adminInfo.$state.id || !(row.status == 3 || row.status == 4)
          },
          click: row => {
            FormRef.value.open('重新发起', row)
          }
        },
        {
          name: 'cancel',
          title: '取消',
          type: 'danger',
          icon: 'el-icon-Open',
          render: 'basicButton',
          disabled: row => {
            return row.createBy != adminInfo.$state.id || row.status != 1
          },
          click: async row => {
            // cancelLeave(row)
            const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
              confirmButtonText: '确定',
              cancelButtonText: '取消',
              inputType: 'textarea',
              inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
              inputErrorMessage: '取消原因不能为空'
            })
            // 发起取消
            let data = {
              id: row.id,
              processInstanceId: row.processInstanceId,
              reason: value
            }
            await cancel(data)
            ElMessage.success('取消成功')
            // 加载数据
            tableStore.index()
          }
        }
      ]
    }
  ],

  beforeSearchFun: () => {
    tableStore.table.params.deptId = tableStore.table.params.deptIndex
    tableStore.table.params.statveList = [2]
    // tableStore.table.params.relationUserName = tableStore.table.params.userName
  },
  exportProcessingData: () => {
        tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.status =
                item.status == 0
                    ? '待提交审批'
                    : item.status == 1
                    ? '审批中'
                    : item.status == 2
                    ? '审批通过'
                    : item.status == 3
                    ? '审批不通过'
                    : item.status == 4
                    ? '已取消':item.status == 5
                    ? '同步台账成功':'/'
            return item
        })
    }
})
tableStore.table.params.status = ''
tableStore.table.params.state = ''
tableStore.table.params.searchValue = ''

provide('tableStore', tableStore)

onMounted(() => {
  tableStore.index()
})

/** 处理审批按钮 */
const handleAudit = (instanceId: any, historyInstanceId: any) => {
  push({
    name: 'BpmProcessInstanceDetail',
    state: {
      id: instanceId,
      historyInstanceId
    }
  })
}

const addFormModel = () => {
}

watch(
    () => currentRoute.value.path,
    () => {
      if (flag.value && options.history.state.forward?.split('/')[1] == 'bpm') {
        tableStore.index()
        flag.value = false
      }
    },
    {
      deep: true
    }
)
const props = defineProps(['id', 'businessKey'])
watch(() => props.id, async (newValue, oldValue) => {
  if (newValue === 'null') return // 直接返回，避免后续逻辑执行
  const fullId = newValue.split('@')[0]
  let nowTime = Date.now()
  const routeTime = Number(newValue.split('@')[1])
  if (isNaN(routeTime) || nowTime - routeTime > import.meta.env.VITE_ROUTE_TIME_OUT) return // 路由时间超过500ms，则不执行
  await getInfoById({ id: fullId }).then(res => {
    if (res && res.code == 'A0000') {
      if (props.businessKey == '3') {
        FormRef.value.open('报告上传', res.data)
      } else {
        FormRef.value.open('重新发起', res.data)
      }

    }
  })
}, { immediate: true })
</script>

<style scoped lang='scss'>
:deep(.el-upload-list__item) {
  width: 400px;
}

::v-deep .el-input__wrapper {
  // width: 200px !important;
}
</style>
